package PureMessage::Manager::Component;

1;

package PureMessage::Manager::Component::ProgressBar;
use base 'PureMessage::Manager::Component';

sub new {
	my $class = shift;
	my $params = shift || {};
	$params->{percent} ||=  1;
	my $self = bless { %{$params} }, $class;
	return $self;
}

sub show {
	my $self = shift;
	my $width = $self->{width} ? "width=\"$self->{width}\"" : "";
	
	my $table;
	$table = ($self->{percent} >= 100) ?
		"<table $width class=\"progress_bar\">\n<tr>\n\t<td width=\"100%\" class=\"progress_bar\">|</td>\n</tr></table>"
		: "<table $width class=\"progress_bar\">\n<tr>\n\t<td width=\"$self->{percent}%\" class=\"progress_bar\">|</td>\n\t<td></td>\n</tr>\n</table>";
	
	return $table;
}

1;

package PureMessage::Manager::Component::CyclicalBar;
use base 'PureMessage::Manager::Component';

sub new {
	my $class = shift;
	my $params = shift;
	my $self = bless { %{$params} }, $class;
	return $self;
}

1;

package PureMessage::Manager::Component::CheckList;
use base 'PureMessage::Manager::Component';

sub new {
	my $class = shift;
	my $params = shift;
	my $self = bless { %{$params} }, $class;
	return $self;
}

sub failure_occurred {
	my $self = shift;
	
	for $key (keys %{$self->{items}}) {
		return 1 if $self->{items}->{$key}->{status} eq 'failed';
	}
	return 0;
}

sub set_status {
	my $self = shift;
	my $item = shift;
	my $status = shift;
	
	$self->{items}->{$item}->{status} = $status if exists $self->{items}->{$item};
}

sub add_item {
	my $self = shift;
	my $key = shift;
	my $value = shift;
	$self->{items}->{$item} =  $value;
}

sub show {
	my $self = shift;
	
	my $cl = "<table class=\"checklist\">\n";
	
	my @items = sort { $self->{items}->{$a}->{order} <=> $self->{items}->{$b}->{order} } keys %{$self->{items}};

	for my $item (@items) {
		
		my $status = (exists $self->{items}->{$item}->{status}) ?  $self->{items}->{$item}->{status} : '&nbsp;';
		my $status_class = (exists $self->{items}->{$item}->{status}) ?  $self->{items}->{$item}->{status} : 'checklist';
			
		$cl .= 
		"<tr>\n\t<td class=\"checklist\">"
		.$self->{items}->{$item}->{label}
		."</td>\n\t<td class=\"".$status_class."\">".$status
		."</td>\n</tr>\n";
	}
	
	$cl .= 	"</table>";
		
	return $cl;
}

1;
