package PureMessage::Manager::Widget::Dashboard;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Modules;
use strict;

our @ISA = qw(PureMessage::Manager::Widget);

sub new {
    my $CLASS = shift;
    $CLASS = ref($CLASS) || $CLASS;
    my $self = $CLASS->SUPER::new(@_);
    bless($self,$CLASS);
    return $self;
}

sub output {
    my $self = shift;
    my $m = PureMessage::Manager::Modules->new();
    my $i = 0;
    my $bars = $m->get_dashbars($self->{module});
    my $html = "";
    $html .= "<table width='100%' cellpadding=0 cellspacing=0><tr><td valign=top>";
    foreach my $bar ( sort { $a->{position} <=> $b->{position} } values %{$bars} ) {
        next if $bar->{column} ne "left";
        $html .= $self->format_bar($bar);
        $html .= "<br>";
    }
    $html .= "</td><td nowrap='nowrap'>&nbsp;&nbsp;&nbsp;&nbsp;</td><td valign=top>";
    foreach my $bar ( sort { $a->{position} <=> $b->{position} } values %{$bars} ) {
        next if $bar->{column} ne "right";
        $html .= $self->format_bar($bar);
        $html .= "<br>";
    }
    $html .= "</td></tr></table>";
    return $html;
}

sub format_bar {
    my $self = shift;
    my $bar = shift;
    my $html = "";
    my @path = split (/\:\:/, $bar->{path});
    my $module = join("::", @path[0..$#path-1]);
    my $call = join("::", @path);
    my @args = split (/\s+/, $bar->{args});
    my $style = "";
    $self->{title} = $bar->{title};
    
    # DashBar header:
    eval <<EOT;
        require PureMessage::Manager::Response::DashBars::$module;
        \$html = PureMessage::Manager::Response::DashBars::$call(\$self, \@args);
        \$style = \$PureMessage::Manager::Response::DashBars::$call\_style
            if \$PureMessage::Manager::Response::DashBars::$call\_style;
EOT
    if ( $@ ) { 
        $html = "$@ $!";
    }
    
    unless ($style eq "noframe") {
        $html = $self->html_start() . $html . $self->html_end();
    }
    
    return $html;
}

sub html_start {
    my $self = shift;
    return <<EOT;
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
				<tr>
					<td class="tableOutline">
						<table width="100%" border="0" cellpadding="4" cellspacing="1">
							<tr>
								<td class="tableHeader" nowrap="nowrap">
					$self->{title}
								</td>
							</tr>
							<tr>
								<td class="tableContent">
EOT
}

sub html_end {
    my $self = shift;
    return <<EOT;
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
EOT
}

1;



