package PureMessage::Manager::Widget::Error;
use PureMessage::Manager::Widget;
use strict;

our @ISA = qw(PureMessage::Manager::Widget);

sub new {
        my $CLASS = shift;
        $CLASS = ref($CLASS) || $CLASS;
        my $this = $CLASS->SUPER::new(@_);

        bless($this,$CLASS);
        return $this;
}

sub output {
        my $this = shift;
        my $data;
        $this->config_default( css_class => 'error');
        my $class = $this->get('css_class');
        $data .= <<EOT;
<table cellpadding=4 cellspacing=0 width="100%">
<tr>
<td width="1" class="infoBox">
    <img src="/img/warning.gif">
</td>
<td class="infoBox">        
EOT
        my $errors = $this->get('error');
        return unless $errors;
        my $count = scalar(@$errors);
	# doing an $#{@$errors} gives the following so work around it
	# An error occured while sending the response. Bizarre copy of ARRAY in leave at
        for (my $i = 0; $i< $count; $i++) {
                my $error = $errors->[$i];
                # TODO this needs an ERROR icon.
		$data .= $error;
                $data .= $i == $count - 1? "\n" : "<BR>\n";
        }
        $data .= "</td></tr></table><br>\n";
        return $data;
}

1;


=pod

=cut


=head1 NAME

PureMessage::Manager::Widget::Error

=head1 SYNOPSIS

 use PureMessage::Manger::Widget::Error;

 my $WIDGET = new PureMessage::Manager::Widget();

 my @errors = ("Foo had a fatal Baz","Bar X'ed Y");
 
 my $er = $WIDGET->widget(
                 CLASS =>'PureMessage::Manager::Widget::Error',
                 error => \@errors
                );
 
 # output a formatted list of errors
 print $er->output();

=head1 DESCRIPTION

 The error widget will generate a nicely formatted list of errors.

=head1 METHODS

=over 4

=item new( %options)

Creates an toolbar object. Options are:

=over 4

=item name

Name of this widget.

=item error

A reference to an array of error strings to display. 

=back

=item output()

Returns the text of the formatted errors.

=back

=cut





