package PureMessage::Manager::Widget::PaneBox;
use strict;

our @ISA = qw(PureMessage::Manager::Widget);

sub new {
        my $CLASS = shift;
        $CLASS = ref($CLASS) || $CLASS;
        my $this = $CLASS->SUPER::new(@_);
        $this->config_default(html_table_bgcolor => '#F2F2F2',
                              width     =>'100%',
                              td_extra  =>'',
                              css_border_color  =>'black',
                              html_cell_padding => 2,
                              html_cell_spacing => 2,
                             );
        bless($this,$CLASS);
        return $this;
}

sub output {
        my $this = shift;
        my $data;
        my $width = $this->get('width');
        my $tb = $this->get('toolbar');
        my $html_table_bgcolor = $this->get('html_table_bgcolor');
        my $extra = $this->get('td_extra');
        my $css_border_color = $this->get('css_border_color');
        my $html_cell_padding = $this->get('html_cell_padding');
        my $html_cell_spacing = $this->get('html_cell_spacing');

        my $bottom_width;
        $bottom_width = ($tb or $this->get('suppress_bottom_border')) ? '0px' : '1px';
        
        $data = "<table bgcolor='$html_table_bgcolor' width='$width' style='border-color: $css_border_color; border-style: solid; border-width: 1px 1px $bottom_width 1px' cellpadding='$html_cell_padding' cellspacing='$html_cell_spacing'>\n";
        $data .= "<tr>\n<td $extra>\n";
        
        my $title = $this->get('title');
        my $content = $this->get('content');
        $data .= "<h2>&nbsp;&nbsp;$title</h2>\n" if $title;
        
        $data .= $this->get_text($this->get('content'));
        
        $data .= "\n</td>\n</tr>\n";
        $data .= "</table>\n";
        if ($tb) {
          $tb->{width} = $width;
          $data .= "<table cellpadding=0 cellspacing=0 bgcolor=white width='$width'><tr><td>\n";
          $data .= $tb->output() if $tb;
          $data .= "</td></tr>\n";
          $data .= "</table>\n";
        }
        $data .= $this->get('padding');
        return $data;
        
}
    
1;



