package PureMessage::Manager::Widget::ThemeSectionToolbar;
use strict;

our @ISA = qw(PureMessage::Manager::Widget);

sub new {
        my $CLASS = shift;
        $CLASS = ref($CLASS) || $CLASS;
        my $this = $CLASS->SUPER::new(@_);

        bless($this,$CLASS);
        return $this;
}

sub output {
        my $this = shift;
        $this->config_default( width => '100%');
        $this->config_default( align => 'bottom');
        if ($this->get('align') eq "top") {
            return $this->top();
        }
        else {
            return $this->bottom();
        }
}

sub bottom {
        my $this = shift;
        my $data;
        my $tb = $this->toolbar_html();
        my $content = $this->content_html();
        
        $data = <<EOT;
            </td>
        </tr>
	</table>				
    </td>		
    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
</tr>
<tr>
    <td colspan="3" valign="top">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
            $tb
            <td valign="top" width="100%">
                <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tr>
                    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                </tr>
                </table>
            </td>
            $content
        </tr>
        </table>
    </td>
</tr>
</table>
EOT
        return $data; 
}

sub top {
        my $this = shift;
        my $data;
        my $width = $this->get('width');
        my $tb = $this->toolbar_html();
        my $content = $this->content_html();
        $data = <<EOT;
<table border="0" cellpadding="0" cellspacing="0" width=$width>
<tr>
    <td colspan="3" valign="top">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
            $content
            <td valign="bottom" width="100%">
                <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tr>
                    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                </tr>
                </table>
            </td>
            $tb
        </tr>
        </table>
    </td>
</tr>
<tr>
    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
    <td width="100%">
        <table border="0" cellpadding="0" cellspacing="1" width="100%">
        <tr>
            <td class="tableLines">		
EOT
        
        return $data; 
}

sub toolbar_html {
        my $this = shift;
        my $tb = $this->get('toolbar');
        my $outline = <<EOT;
                <tr>
                    <td class="tableOutline" colspan="3"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                </tr>
EOT
        my $top_line = $this->get('align') eq "top" ? $outline : "";
        my $btm_line = $this->get('align') ne "top" ? $outline : "";
        if ($tb) {
            $tb = $tb->output();
            $tb = <<EOT;
            <td>
                <table border="0" cellpadding="0" cellspacing="0">
                $top_line
                <tr>
                    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                    <td>$tb</td>
                    <td class="tableOutline" width="1"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                </tr>
                $btm_line
                </table>
            </td>
EOT
        }
        return $tb;
}    

sub content_html {
        my $this = shift;
        my $content = $this->get('content');
        my $outline = <<EOT;
                <tr>
                    <td class="tableOutline"><img src="/img/x.gif" width="1" height="1" alt=""></td>
                </tr>
EOT
        my $top_line = $this->get('align') ne "top" ? $outline : "";
        my $btm_line = $this->get('align') eq "top" ? $outline : "";
        if ($content) {
            $content = <<EOT;
	    <td>
                <table border="0" cellpadding="0" cellspacing="0">
                $top_line
		<tr>
		    <td nowrap=nowrap>$content</td>
                </tr>
                $btm_line
                </table>
            </td>
EOT
        }
        return $content;
}

1;



